package foele.jini.lease;

/**
 * This type was created in VisualAge.
 */
public class PluggablePolicyLeaseManager extends java.rmi.server.UnicastRemoteObject implements LeasedResourceManager, LeaseManager, PolicyInfo,TickerListener {
	private java.util.Vector LeasedResources = new java.util.Vector();
	private java.util.Hashtable LeaseTable = new java.util.Hashtable();
	private LeasePolicy LeasePolicy;

	private final static class LeaseInfo {
		LeasedResource LeasedResource;
		long since;
		LeaseInfo(LeasedResource LeasedResource,long since){
			this.LeasedResource=LeasedResource;
			this.since=since;
		}
	}
		
	private Ticker Ticker = new Ticker();
/**
 * PluggablePolicyLeaseManager constructor comment.
 * @exception java.rmi.RemoteException The exception description.
 */
public PluggablePolicyLeaseManager() throws java.rmi.RemoteException {
	super();
	setLeasePolicy(new DefaultLeasePolicy(this,new SimpleLease.SimpleLeaseFactory()));
	Ticker.addTickerListener(this);
}
/**
 * This method was created in VisualAge.
 * @param LeasePolicy foele.jini.lease.LeasePolicy
 */
public PluggablePolicyLeaseManager(LeasePolicy LeasePolicy) throws java.rmi.RemoteException{
	this();
	this.LeasePolicy=LeasePolicy;
}
/**
 * addLeasedResource method comment.
 */
public void addLeasedResource(LeasedResource lR) throws java.rmi.RemoteException {
	LeasedResources.addElement(lR);
}
/**
 * cancel method comment.
 */
public void cancel(net.jini.core.lease.Lease lease) throws java.rmi.RemoteException, net.jini.core.lease.UnknownLeaseException {
	System.out.println("cancel :"+ lease);
	Object o=LeaseTable.get(lease);
	if (o!=null){
		LeasedResource LR=((LeaseInfo)o).LeasedResource;
		if (LeasedResources.contains(LR))
			LeaseTable.remove(lease);
		else {
			LeaseTable.remove(lease);
			throw new net.jini.core.lease.UnknownLeaseException();
		}
	}
	else throw new net.jini.core.lease.UnknownLeaseException();
}
/**
 * createNewLease method comment.
 */
public net.jini.core.lease.Lease createNewLease(long leaseFor, LeasedResource leasedresource) throws net.jini.core.lease.LeaseDeniedException, java.rmi.RemoteException {
	System.out.println("create :"+ leaseFor);
	if (!LeasedResources.contains(leasedresource))
		addLeasedResource(leasedresource);
	net.jini.core.lease.Lease lease=LeasePolicy.createNewLease(leaseFor,leasedresource);
	System.out.println(lease);
	LeaseTable.put(lease,new LeaseInfo(leasedresource,System.currentTimeMillis()));
	System.out.println(LeaseTable);
	Ticker.scheduleTick(lease,lease.getExpiration());
	return lease;
}
/**
 * This method was created in VisualAge.
 * @return foele.jini.lease.LeasePolicy
 */
public LeasePolicy getLeasePolicy() {
	return LeasePolicy;
}
/**
 * isValid method comment.
 */
public boolean isValid(net.jini.core.lease.Lease lease) throws java.rmi.RemoteException {
	System.out.println("isValid :"+ lease);
	Object o=LeaseTable.get(lease);
	//System.out.println("o:"+o);
	if (o!=null){
		LeasedResource LR=((LeaseInfo)o).LeasedResource;
		//System.out.println("LeasedResource:"+LR);
		if (LeasedResources.contains(LR)){
			//System.out.println(true);
			return true;
		}
		else {
			LeaseTable.remove(lease);
			//System.out.println(false+" LR ! esiste");
			return false;
		}
	}
	else {
		//System.out.println(false+" o=null");
		return false;
	}
}
/**
 * This method was created in VisualAge.
 * @return long
 * @param lease net.jini.core.lease.Lease
 * @exception net.jini.core.lease.UnknownLeaseException The exception description.
 */
public long leaseLastedFor(net.jini.core.lease.Lease lease) throws net.jini.core.lease.UnknownLeaseException {
	Object o=LeaseTable.get(lease);
	if (o!=null){
		LeaseInfo LI=(LeaseInfo)o;
		LeasedResource LR=((LeaseInfo)o).LeasedResource;
		if (LeasedResources.contains(LR))
			return LI.since;
		else {
			LeaseTable.remove(lease);
			throw new net.jini.core.lease.UnknownLeaseException();
		}
	}
	else throw new net.jini.core.lease.UnknownLeaseException();
}
/**
 * This method was created in VisualAge.
 * @return long
 * @param leasedresource foele.jini.lease.LeasedResource
 */
public long leasesGranted(LeasedResource leasedresource) {
	if (!LeasedResources.contains(leasedresource))
		return 0;
	java.util.Enumeration e=LeaseTable.elements();
	long i=0;
	while(e.hasMoreElements())
		if (((LeaseInfo)e.nextElement()).LeasedResource.equals(leasedresource))
			i++;
	return i;
}
/**
 * This method was created in VisualAge.
 	come primo argomento si aspetta il nome della registrazione rmi del LeasedResourceManager come secondo 
 	il nome della registrazione del LeaseManager come terzo la porta rmi.
 * @param args java.lang.String[]
 */
public static void main(String args[]) throws java.io.IOException {
	System.setOut(new java.io.PrintStream(new foele.io.TeeOutputStream(System.out,new java.io.PrintStream(new java.io.FileOutputStream(PluggablePolicyLeaseManager.class+".log")))));
	String LRMname=args[0];
	String LMname=args[1];
	int port=Integer.parseInt(args[2]);
	try {
		System.setSecurityManager(new java.rmi.RMISecurityManager());
		java.rmi.registry.Registry reg=java.rmi.registry.LocateRegistry.getRegistry(port);
		PluggablePolicyLeaseManager PPLM=new PluggablePolicyLeaseManager();
		reg.rebind(LRMname,PPLM);
		reg.rebind(LMname,PPLM);
		System.out.println("PPLM running correctly");
	}
	catch (Exception e){
		e.printStackTrace(System.out);
	}
	
}
/**
 * removeLeasedResource method comment.
 */
public void removeLeasedResource(LeasedResource lR) throws java.rmi.RemoteException {
	LeasedResources.removeElement(lR);
}
/**
 * renew method comment.
 */
public long renew(long leaseFor, net.jini.core.lease.Lease lease) throws net.jini.core.lease.LeaseDeniedException, java.rmi.RemoteException, net.jini.core.lease.UnknownLeaseException {
	System.out.println("renew :"+ lease);
	Object o=LeaseTable.get(lease);
	if (o!=null){
		LeasedResource LR=((LeaseInfo)o).LeasedResource;
		if (LeasedResources.contains(LR)){
			long leasedFor=LeasePolicy.renew(leaseFor,lease);
			Ticker.scheduleTick(lease,leasedFor);
			return leasedFor;
		}
		else {
			LeaseTable.remove(lease);
			throw new net.jini.core.lease.UnknownLeaseException();
		}
	}
	else throw new net.jini.core.lease.UnknownLeaseException();
}
/**
 * This method was created in VisualAge.
 * @param newValue foele.jini.lease.LeasePolicy
 */
public void setLeasePolicy(LeasePolicy newValue) {
	this.LeasePolicy = newValue;
}
/**
 * This method was created in VisualAge.
 * @param TE foele.jini.lease.TickerEvent
 */
public void tick(TickerEvent TE) {
	System.out.println("Tick:"+TE);
	LeaseTable.remove(TE.getLease());
}
}
